﻿Type=StaticCode
Version=1.8
ModulesStructureVersion=1
B4R=true
@EndOfDesignText@
' implements a normal motor in the
' arduino motor shield

Sub Process_Globals
	' ports
	Dim DirectionA As Pin ' 12
	Dim SpeedA As Pin ' 3
	Dim BrakeA As Pin ' 9
	Dim CurrentA As Pin ' 0
	Dim DirectionB As Pin ' 13
	Dim SpeedB As Pin ' 11
	Dim BrakeB As Pin ' 8
	Dim CurrentB As Pin ' 1
End Sub

' initialize everything
Sub Init
	DirectionA.Initialize(12,DirectionA.MODE_OUTPUT)
	SpeedA.Initialize(3,SpeedA.MODE_OUTPUT)
	BrakeA.Initialize(9,BrakeA.MODE_OUTPUT)
	CurrentA.Initialize(0,CurrentA.MODE_INPUT)
	DirectionB.Initialize(13,DirectionB.MODE_OUTPUT)
	SpeedB.Initialize(11,SpeedB.MODE_OUTPUT)
	BrakeB.Initialize(8,BrakeB.MODE_OUTPUT)
	CurrentB.Initialize(1,CurrentB.MODE_INPUT)
	BrakeON("a")
	BrakeON("b")
	DirectionForward("a")
	DirectionForward("b")
	Speed("a",255)
	Speed("b",255)
End Sub

' these routines should be self explanitory

Sub BrakeON(Motr As String)
	If Motr = "b" Then
		BrakeB.DigitalWrite(True)
	Else ' default to a
		BrakeA.DigitalWrite(True)
	End If
End Sub

Sub BrakeOFF(Motr As String)
	If Motr = "b" Then
		BrakeB.DigitalWrite(False)
	Else ' default to a
		BrakeA.DigitalWrite(False)
	End If
End Sub

Sub DirectionForward(Motr As String)
	If Motr = "b" Then
		DirectionB.DigitalWrite(True)
	Else ' default to a
		DirectionA.DigitalWrite(True)
	End If
End Sub

Sub DirectionReverse(Motr As String)
	If Motr = "b" Then
		DirectionB.DigitalWrite(False)
	Else ' default to a
		DirectionA.DigitalWrite(False)
	End If
End Sub

Sub Speed(Motr As String, PWM As UInt)
	If Motr = "b" Then
		SpeedB.AnalogWrite(PWM)
	Else ' default to a
		SpeedA.AnalogWrite(PWM)
	End If
End Sub
